import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React from 'react';
import PropTypes from 'prop-types';
import { FormModel } from './FormModel';

var connectForm = function connectForm(WrappedComponent) {
  var _class, _temp;

  var HOC = (_temp = _class = function (_React$Component) {
    _inherits(HOC, _React$Component);

    function HOC(props, context) {
      _classCallCheck(this, HOC);

      var _this = _possibleConstructorReturn(this, _React$Component.call(this, props, context));

      _this.formModel = context.formModel;
      return _this;
    }

    HOC.prototype.componentDidMount = function componentDidMount() {
      var _this2 = this;

      this.subscriberId = this.formModel.addSubscriber(function () {
        _this2.forceUpdate();
      });
    };

    HOC.prototype.componentWillUnmount = function componentWillUnmount() {
      this.formModel.removeSubscriber(this.subscriberId);
    };

    HOC.prototype.render = function render() {
      return React.createElement(WrappedComponent, { form: this.context.formModel.getPublic() });
    };

    return HOC;
  }(React.Component), _class.contextTypes = {
    formModel: PropTypes.instanceOf(FormModel).isRequired
  }, _temp);

  return HOC;
};

export { connectForm };