'use strict';

exports.__esModule = true;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _FieldModel = require('./FieldModel');

var _FieldModel2 = _interopRequireDefault(_FieldModel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FieldsModel = function () {
  function FieldsModel() {
    var _this = this;

    (0, _classCallCheck3.default)(this, FieldsModel);

    this.get = function () {
      return _this.__get__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.field = function () {
      return _this.__field__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.add = function () {
      return _this.__add__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.remove = function () {
      return _this.__remove__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.validate = function () {
      return _this.__validate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.addErrors = function () {
      return _this.__addErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reload = function () {
      return _this.__reload__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.list = function () {
      return _this.__list__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.data = function () {
      return _this.__data__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reset = function () {
      return _this.__reset__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.init = function () {
      return _this.__init__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeDirty = function () {
      return _this.__makeDirty__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeSubmitted = function () {
      return _this.__makeSubmitted__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isValid = function () {
      return _this.__isValid__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isTouched = function () {
      return _this.__isTouched__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.values = function () {
      return _this.__values__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.errors = function () {
      return _this.__errors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getPublic = function () {
      return _this.__getPublic__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.fields = {};
  }

  FieldsModel.prototype.__get__REACT_HOT_LOADER__ = function __get__REACT_HOT_LOADER__(name) {
    return this.fields[name];
  };

  FieldsModel.prototype.__field__REACT_HOT_LOADER__ = function __field__REACT_HOT_LOADER__(name) {
    return this.fields[name];
  };

  FieldsModel.prototype.__add__REACT_HOT_LOADER__ = function __add__REACT_HOT_LOADER__(props) {
    var field = new _FieldModel2.default(props);
    this.fields[field.name] = field;
    return field;
  };

  FieldsModel.prototype.__remove__REACT_HOT_LOADER__ = function __remove__REACT_HOT_LOADER__(name) {
    delete this.fields[name];
  };

  FieldsModel.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__(name) {
    if (name) {
      this.fields[name].validate();
    } else {
      this.list().forEach(function (field) {
        return field.validate();
      });
    }
  };

  FieldsModel.prototype.__addErrors__REACT_HOT_LOADER__ = function __addErrors__REACT_HOT_LOADER__(errors) {
    this.list().forEach(function (field) {
      var error = errors[field.name];
      field.setFormErrors(error);
    });
  };

  FieldsModel.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    this.list().forEach(function (field) {
      return field.reload();
    });
  };

  FieldsModel.prototype.__list__REACT_HOT_LOADER__ = function __list__REACT_HOT_LOADER__() {
    return (0, _values2.default)(this.fields);
  };

  FieldsModel.prototype.__data__REACT_HOT_LOADER__ = function __data__REACT_HOT_LOADER__() {
    var data = {};
    this.list().forEach(function (field) {
      return data[field.name] = field.value;
    });
    return data;
  };

  FieldsModel.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__(name) {
    if (name) {
      this.fields[name].reset();
    } else {
      this.list().forEach(function (field) {
        return field.reset();
      });
    }
  };

  FieldsModel.prototype.__init__REACT_HOT_LOADER__ = function __init__REACT_HOT_LOADER__() {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    this.list().forEach(function (field) {
      return field.setValue(data[field.name]);
    });
  };

  FieldsModel.prototype.__makeDirty__REACT_HOT_LOADER__ = function __makeDirty__REACT_HOT_LOADER__() {
    this.list().forEach(function (field) {
      return field.makeDirty();
    });
  };

  FieldsModel.prototype.__makeSubmitted__REACT_HOT_LOADER__ = function __makeSubmitted__REACT_HOT_LOADER__() {
    this.list().forEach(function (field) {
      return field.makeSubmitted();
    });
  };

  FieldsModel.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    return this.list().every(function (field) {
      return field.isValid();
    });
  };

  FieldsModel.prototype.__isTouched__REACT_HOT_LOADER__ = function __isTouched__REACT_HOT_LOADER__() {
    return this.list().some(function (field) {
      return field.touched;
    });
  };

  FieldsModel.prototype.__values__REACT_HOT_LOADER__ = function __values__REACT_HOT_LOADER__() {
    var values = {};
    this.list().filter(function (field) {
      return !field.isExcluded();
    }).forEach(function (field) {
      return values[field.name] = field.value;
    });
    return values;
  };

  FieldsModel.prototype.__errors__REACT_HOT_LOADER__ = function __errors__REACT_HOT_LOADER__() {
    var errors = {};
    this.list().forEach(function (field) {
      return errors[field.name] = field.getErrors();
    });
    return errors;
  };

  FieldsModel.prototype.__getPublic__REACT_HOT_LOADER__ = function __getPublic__REACT_HOT_LOADER__() {
    var fields = {};
    this.list().forEach(function (field) {
      return fields[field.name] = field.getPublic();
    });
    return fields;
  };

  return FieldsModel;
}();

var _default = FieldsModel;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FieldsModel, 'FieldsModel', '/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/Form/FieldsModel.js');

  __REACT_HOT_LOADER__.register(_default, 'default', '/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/Form/FieldsModel.js');
}();

;